import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;

public class TimServer implements Tim {

    public long getTim(){
        System.out.println("Server is called... "+System.currentTimeMillis());
        return System.currentTimeMillis();
    }

    public Work compute(Work a){
        a.compute();
        return a;
    }

    public static void main(String[] args) throws Throwable {
        
        //if(System.getSecurityManager() == null)
        //    System.setSecurityManager(new SecurityManager());

        Tim t = new TimServer();

        //System.out.println("t.getTim():"+t.getTim());

        // create a wrapper we can store in registry.
        Tim stub = (Tim)UnicastRemoteObject.exportObject(t,0);
        
        // find registry instance.
        Registry r = LocateRegistry.getRegistry();

        // bind "Tim" to reference of stub.
        r.rebind("Tim",stub);
    }
}

